import { Command } from "../CommandHandler.js";
import { world } from "@minecraft/server";
import main from "../config.js";

// All rights reserved @bluemods.lol - discord account. || please report any bugs or glitches in our discord server https://dsc.gg/bluemods
const playerRequest = {};
const cooldowns = {};

Command.register({
    name: "tpa",
    description: "",
    aliases: [],
}, (data, args) => {
    const { player } = data;
    const { id, name } = player;
    const send = "send", accept = 'accept', decline = 'decline';

    if (send.includes(args[0])) {
        const currentTime = Date.now();
        if (cooldowns[id] && currentTime - cooldowns[id] < 10000) {
            player.sendMessage(`§bBlueMods §7>> §aPlease wait §e10s §abefore sending another request.`);
            return player.runCommandAsync(`playsound random.break @s`);
        }
        
        cooldowns[id] = currentTime;

        const [foundPlayer] = world.getPlayers({ name: args[1] });
        if (!foundPlayer) {
            player.sendMessage(`§bBlueMods §7>> §aCan\'t find the player: §e${args[1]}`);
            return player.runCommandAsync(`playsound random.break @s`);
        }
        if (foundPlayer == player) { 
            player.sendMessage("§bBlueMods §7>> §aYou can't send a teleport request to yourself");
            return player.runCommandAsync(`playsound random.break @s`);
        }
        player.sendMessage(`§bBlueMods §7>> §aYou send a teleport request to §e${foundPlayer.name}`);
        player.runCommandAsync(`playsound note.bell @s`);
        foundPlayer.sendMessage(`§bBlueMods §7>> §e${name} §asent you a teleport request`);
        foundPlayer.runCommandAsync(`playsound random.orb @s`);
        playerRequest[foundPlayer.id] = {name, id};
    } else if (accept.includes(args[0])) {
        if (!playerRequest.hasOwnProperty(id)) return player.sendMessage('§bBlueMods §7>> §aYou don\'t have any teleport requests');
        const { id: requesterId, name: requesterName } = playerRequest[id];
        const requester = world.getAllPlayers().find(({id}) => id === requesterId);
        if (!requester) {
            player.sendMessage(`§bBlueMods §7>> §aCan\'t find the player: ${requesterName}`);
            return player.runCommandAsync(`playsound random.break @s`);
        }
        requester.sendMessage(`§bBlueMods §7>> §e${name}§a has accepted your teleport request`);
        delete playerRequest[id];
        if (requester.teleport) {
            player.runCommandAsync(`tp "${requesterName}" "${player.name}"`);
            requester.runCommandAsync(`playsound random.levelup @s`);
            player.runCommandAsync(`playsound random.levelup @s`)
        }
    } else if (decline.includes(args[0])) {
        if (!playerRequest.hasOwnProperty(id)) return player.sendMessage('§bBlueMods §7>> §aThere are no teleport requests to decline');
        const { id: requesterId, name: requesterName } = playerRequest[id];
        const requester = world.getAllPlayers().find(({id}) => id === requesterId);
        if (!requester) return player.sendMessage(`§bBlueMods §7>> §Ccan\'t find the player: §e${requesterName}`);
        requester.sendMessage(`§bBlueMods §7>> §e${player.name} §chas declined your teleport request`);
        requester.runCommandAsync(`playsound random.break @s`);
        player.sendMessage(`§bBlueMods §7>> §aYou have declined ${requesterName}§a's request`);
        delete playerRequest[id];
    } else { 
            player.sendMessage('§bBlueMods §7>> §aYou have to choose between §7( §esend §7/ §aaccept §7/ §cdecline §7)');
            return player.runCommandAsync(`playsound random.break @s`);
    }
});
