import { world, system } from "@minecraft/server";
import { Command } from "../CommandHandler.js";
import main from "../config.js";

// All rights reserved @bluemods.lol - discord account. || Please report any bugs or glitches in our discord server https://dsc.gg/bluemods

Command.register({
    name: "notify",
    description: "",
    aliases: [],
    permission: (player) => player.hasTag(main.adminTag),
}, async (data, args) => {
    const player = data.player;
    if (!args[0]) {
        player.sendMessage('§4Error §7>> §aTry to mention a player to notify. !notify <player>');
        return player.runCommandAsync('playsound random.break @s');
    }

    let targetPlayer;
    try {
        targetPlayer = world.getPlayers().find(p => p.name === args[0]);
    } catch (error) {
        return player.sendMessage(`§4Error §7>> §aError finding player: ${error.message}`);
    }

    if (!targetPlayer) {
        player.sendMessage('§4Error §7>> §aPlayer name must be someone currently on the server');
        return player.runCommandAsync('playsound random.break @s');
    }

    try {
        if (!targetPlayer.hasTag("notify")) {
            await system.run(() => targetPlayer.addTag("notify"));
            player.runCommandAsync(`playsound note.bell @s`);
            player.sendMessage(`§bBlueMods §7>> §aSuccessfully §3added §anotify status to §e${targetPlayer.name}`);
        } else {
            await system.run(() => targetPlayer.removeTag("notify"));
            player.runCommandAsync(`playsound note.bell @s`);
            player.sendMessage(`§bBlueMods §7>> §aSuccessfully §cremoved §anotify status from §e${targetPlayer.name}`);
        }
    } catch (error) {
        return player.sendMessage(`§4Error §7>> §aError modifying player tags: ${error.message}`);
    }
});
